## frama-c 20110201+carbon+dfsg

=== Makefile ===
##########################################################################
#                                                                        #
#  This file is part of Frama-C.                                         #
#                                                                        #
#  Copyright (C) 2007-2011                                               #
#    CEA   (Commissariat  l'nergie atomique et aux nergies            #
#           alternatives)                                                #
#    INRIA (Institut National de Recherche en Informatique et en         #
#           Automatique)                                                 #
#                                                                        #
#  you can redistribute it and/or modify it under the terms of the GNU   #
#  Lesser General Public License as published by the Free Software       #
#  Foundation, version 2.1.                                              #
#                                                                        #
#  It is distributed in the hope that it will be useful,                 #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#  GNU Lesser General Public License for more details.                   #
#                                                                        #
#  See the GNU Lesser General Public License version v2.1                #
#  for more details (enclosed in the file licenses/LGPLv2.1).            #
#                                                                        #
##########################################################################

# This file is the main makefile of Frama-C.

FRAMAC_SRC=.
MAKECONFIG_DIR=share

include share/Makefile.common

###################
# Frama-C Version #
###################

VERSION=$(shell $(SED) -e 's/\\(.*\\)/\\1/' VERSION)

ifeq ($(findstring +dev,$(VERSION)),+dev)
DEVELOPMENT=yes
else
DEVELOPMENT=no
endif

###########################
# Global plugin variables #
###########################

# the directory where compiled plugin files are stored
PLUGIN_LIB_DIR	= lib/plugins
PLUGIN_GUI_LIB_DIR= lib/plugins/gui

# the directory where the other Makefiles are
FRAMAC_SHARE	= share

# set it to yes to tell Makefile.dynamic than we come from here
FRAMAC_MAKE	=yes

# Shared lists between Makefile.plugin and Makefile :
# initialized them as "simply extended variables" (with :=)
# for a correct behavior of += (see section 6.6 of GNU Make manual)
PLUGIN_LIST	:=
PLUGIN_DYN_EXISTS:="no"
PLUGIN_DYN_LIST :=
PLUGIN_CMO_LIST	:=
PLUGIN_CMX_LIST	:=
PLUGIN_DYN_CMO_LIST :=
PLUGIN_DYN_CMX_LIST :=
PLUGIN_INTERNAL_CMO_LIST:=
PLUGIN_INTERNAL_CMX_LIST:=
PLUGIN_DEP_GUI_CMO_LIST:=
PLUGIN_DEP_GUI_CMX_LIST:=
PLUGIN_GUI_CMO_LIST:=
PLUGIN_GUI_CMX_LIST:=
PLUGIN_DYN_DEP_GUI_CMO_LIST:=
PLUGIN_DYN_DEP_GUI_CMX_LIST:=
PLUGIN_DYN_GUI_CMO_LIST :=
PLUGIN_DYN_GUI_CMX_LIST :=
PLUGIN_TYPES_CMO_LIST :=
PLUGIN_TYPES_CMX_LIST :=
PLUGIN_DEP_LIST:=
PLUGIN_DOC_LIST :=
PLUGIN_DOC_DIRS :=
PLUGIN_DISTRIBUTED_LIST:=
PLUGIN_DIST_TARGET_LIST:=
PLUGIN_DIST_DOC_LIST:=
PLUGIN_BIN_DOC_LIST:=
PLUGIN_DIST_EXTERNAL_LIST:=
PLUGIN_TESTS_LIST:=
PLUGIN_DISTRIBUTED_NAME_LIST:=

###############################
# Additional global variables #
###############################

# put here any config option for the binary distribution outside of
# plugins
CONFIG_DISTRIB_BIN:=

# additional compilation targets for 'make all'.
# cannot be delayed after 'make all'
EXTRAS	= ptests

# Directories containing some source code
SRC_DIRS= ptests $(PLUGIN_LIB_DIR)

# Directory containing source code documentation
DOC_DIR	= doc/code

# Source files to document
MODULES_TODOC=

# Directories containing some source code
SRC_DIRS+= $(FRAMAC_SRC_DIRS)

# Directories to include when compiling
INCLUDES=$(addprefix -I , $(FRAMAC_SRC_DIRS)) -I $(PLUGIN_LIB_DIR) -I lib

# Directories to include for ocamldep
INCLUDES_FOR_OCAMLDEP= $(patsubst +%,.,$(INCLUDES) $(GUI_INCLUDES))

# Ocamldep flags
DEP_FLAGS= $(INCLUDES_FOR_OCAMLDEP)

# Files for which dependencies are computed
FILES_FOR_OCAMLDEP+=$(PLUGIN_LIB_DIR)/*.mli \
		$(addsuffix /*.mli, $(UNPACKED_DIRS)) \
		$(addsuffix /*.ml, $(UNPACKED_DIRS))

# Flags to use by ocamlc and ocamlopt
ifeq ($(DEVELOPMENT),yes)
ifeq ($(HAS_OCAML312),yes)
DEV_FLAGS=$(FLAGS) -warn-error +a
else
DEV_FLAGS=$(FLAGS) -warn-error A
endif
else
DEV_FLAGS=$(FLAGS)
endif

BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
	  $(OCAMLVIZ_COMPILER_BYTE)
OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT)

BLINKFLAGS = $(BFLAGS) -linkall -custom
OLINKFLAGS = $(OFLAGS) -linkall

# Libraries generated by Frama-C
GEN_BYTE_LIBS=
GEN_OPT_LIBS=

# Libraries used in Frama-C
BYTE_LIBS = nums.cma unix.cma bigarray.cma str.cma dynlink.cma \
	$(GEN_BYTE_LIBS)
OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa

ifeq ("$(NATIVE_DYNLINK)","yes")
OPT_LIBS+= dynlink.cmxa
endif

OPT_LIBS+= $(GEN_OPT_LIBS)

ICONS:=  $(addprefix share/, \
		frama-c.ico frama-c.gif left.png right.png \
		relies_on_hyp.png failed.png maybe.png attach.png \
		check.png \
	)

# Kernel files to be included in the distribution.
# Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
# than *.ml* files in their directory.
# NB: configure for the distribution is generated in the distrib directory
# itself, rather than copied: otherwise, it could include references to
# non-distributed plug-ins.
DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
      share/frama-c.WIN32.rc share/frama-c.Unix.rc			\
      $(ICONS)								\
      man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html			\
      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
      doc/code/toc_head.htm doc/code/toc_tail.htm			\
      tests/*/*.c tests/*/*.h tests/*/*.ml				\
      ptests/*.ml* configure.in Makefile share/Makefile.kernel		\
      share/Makefile.plugin share/Makefile.dynamic			\
      share/Makefile.dynamic_config.internal				\
      share/Makefile.dynamic_config.external Changelog config.h.in	\
      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
      share/libc/*.c share/libc/*.h share/libc/sys/*.h			\
      share/libc/netinet/*.h share/acsl.el 				\
      share/configure.ac share/Makefile.config.in			\
      share/Makefile.common share/Makefile.plugin			\
      share/Makefile.dynamic		                                \
      share/Makefile.dynamic_config.external				\
      share/Makefile.dynamic_config.internal             		\
      $(filter-out %kui%,src/kernel/*.ml*)		                \
      external/hptmap.ml* external/unmarshal*.ml*			\
      src/ai/*.ml* src/buckx/*.ml* src/buckx/*.c src/gui/*.ml*		\
      src/lib/*.ml* src/logic/*.ml* src/memory_state/*.ml*		\
      src/misc/*.ml* src/project/*.ml* src/toplevel/*.ml*		\
      src/type/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
      bin/sed_inplace INSTALL INSTALL_WITH_WHY .make-clean		\
      .make-clean-stamp .make-ocamlgraph-stamp

################
# Main targets #
################

ifneq ($(ENABLE_GUI),no)
ifeq ($(HAS_LABLGTK),yes)
EXTRAS	+= gui
endif
endif

all:: byte $(OCAMLBEST) $(EXTRAS)

.PHONY: top opt byte dist bdist archclean rebuild
top: bin/toplevel.top$(EXE)

byte:: bin/toplevel.byte$(EXE) \
      share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-byte FRAMAC_LIBDIR=lib/fc

opt:: bin/toplevel.opt$(EXE) \
     share/Makefile.dynamic_config share/Makefile.kernel
	$(MAKE) install-kernel-opt FRAMAC_LIBDIR=lib/fc

dist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" all

bdist: clean
	$(QUIET_MAKE) OPTIM="-unsafe -noassert" DEBUG="" byte

ifneq ("$(OCAMLGRAPH_LOCAL)","")
archclean: clean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL) distclean
	cd $(OCAMLGRAPH_LOCAL) ; ./configure

rebuild: archclean
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(QUIET_MAKE) all
else
archclean: clean

rebuild: archclean
	$(QUIET_MAKE) all
endif

############
# Coverage #
############

USE_COVERAGE_TOOL=no
ifeq ($(USE_COVERAGE_TOOL),yes)
COVERAGE_PATH=.
COVERAGE_PREPRO=camlp4o -no_quot -filter $(COVERAGE_PATH)/coverage_filter.cmo
COVERAGE_COMPILER_BYTE=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_COMPILER_OPT=-I $(COVERAGE_PATH) -pp "$(COVERAGE_PREPRO)"
COVERAGE_LIB_BYTE=coverage.cma
COVERAGE_LIB_OPT=coverage.cmxa
endif

INCLUDES+=$(COVERAGE_COMPILER_BYTE)
GEN_BYTE_LIBS+=$(COVERAGE_LIB_BYTE)
GEN_OPT_LIBS+=$(COVERAGE_LIB_OPT)
SRC_DIRS+=$(COVERAGE_PATH)

########################
# Ocamlviz (profiling) #
########################

# To use OCamlviz you need to fix its makefile :-(
# In $(OCAMLVIZ_PATH)/Makefile.in change the line
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo src/ocamlviz_threads.cmo
# into
# OCAMLVIZCMO = $(PROTOCOLCMO) src/monitor_impl.cmo src/ocamlviz.cmo
# and
# cp -f src/ocamlviz.mli src/ocamlviz.cmi src/ocamlviz_threads.cmi $(OCAMLLIB)
# into
# cp -f src/ocamlviz.mli src/ocamlviz.cmi $(OCAMLLIB)
#
# Then run "./configure && make && make install" in $(OCAMLVIZ_PATH)
# Only one instance of Frama-C can be launched at a time when Ocamlviz is on.
USE_OCAMLVIZ_TOOL=no
ifeq ($(USE_OCAMLVIZ_TOOL),yes)
OCAMLVIZ_PATH=~/src/ocamlviz
OCAMLVIZ_COMPILER_BYTE=-I $(OCAMLVIZ_PATH)/src # -pp "camlp4 pa_o.cmo str.cma $(OCAMLVIZ_PATH)/camlp4/pa_ocamlviz.cmo pr_o.cmo"
# Seems really broken and generates fatal warnings
OCAMLVIZ_COMPILER_OPT=-I $(OCAMLVIZ_PATH)/src
OCAMLVIZ_LIB_BYTE=~/lib/ocaml/libocamlviz.cma
OCAMLVIZ_LIB_OPT=~/lib/ocaml/libocamlviz.cmxa
endif

BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)

##############
# Ocamlgraph #
##############

ifneq ("$(OCAMLGRAPH_LOCAL)","")

lib/graph.cmi: .make-ocamlgraph $(wildcard $(OCAMLGRAPH_LOCAL)/src/*.ml*) \
		$(OCAMLGRAPH_LOCAL)/Makefile
	$(PRINT_BUILD) ocamlgraph
	$(MAKE) -C $(OCAMLGRAPH_LOCAL)
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

lib/graph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@

GENERATED+= lib/graph.cmo lib/graph.cmi
ifneq ($(OCAMLOPT),no)
GENERATED+= lib/graph.cmx lib/graph.o
endif

GRAPH_BYTE_LIBS=lib/graph.cmo
GRAPH_OPT_LIBS=lib/graph.cmx
GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)

.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma

# viewgraph and  dgraph (included in ocamlgraph)
ifeq ($(HAS_GNOMECANVAS),yes)

lib/viewgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/viewgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@

lib/dgraph.cmi: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmo: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.cmx: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

lib/dgraph.o: lib/graph.cmi
	$(PRINT_CP) $@
	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@

GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
ifneq ($(OCAMLOPT),no)
GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
endif

GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)
