=== debian/changelog ===
frama-c (20110201+carbon+dfsg-2build2) oneiric; urgency=low

  * No-change rebuild for new lablgtk ABI 

 -- Iain Lane <laney@debian.org>  Sat, 24 Sep 2011 09:26:39 +0100

frama-c (20110201+carbon+dfsg-2build1) oneiric; urgency=low

  * Rebuild to pick up ocaml fixes on armel.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 24 Aug 2011 16:40:54 -0600

frama-c (20110201+carbon+dfsg-2) unstable; urgency=low

  * Add "-I +ocamlgraph" to DYN_{O,B}LINKFLAGS, needed for plugins to link.
    - add 0003-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch
    - add libocamlgraph-ocaml-dev to frama-c-base's runtime dependencies.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 25 Apr 2011 12:03:31 +0200

frama-c (20110201+carbon+dfsg-1) unstable; urgency=low

  * New upstream release:
    - Update copyright file.
    - Remove all patches, integrated by upstream.
    - Add patches:
      + 0001-Value-Analysis-Carbon-patchlevel-1.patch
      + 0002-Fix-for-issue-727.patch
  * Fix Categories field in frama-c.desktop (Closes: #610432) (LP: #613853).
  * No need to exclude custom bytecode binaries when running dh_strip.
    (thanks to patch applied in OCaml >= 3.12.0-5)

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 23 Apr 2011 18:47:13 +0200
