=== debian/control ===
Source: frama-c
Section: devel
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 7.0.50~),
 ocaml-nox (>= 3.12.0~),
 ocaml-best-compilers,
 dh-ocaml (>= 0.9~),
 graphviz,
 libocamlgraph-viewer-ocaml-dev (>> 1.4~),
 liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
 liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
Standards-Version: 3.9.0
Homepage: http://frama-c.com/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git

Package: frama-c
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 frama-c-base (= ${binary:Version}),
 graphviz,
 emacs | emacsen
Recommends:
 why (>= 2.19+dfsg-2),
Description: Framework for source code analysis of software written in C
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the graphical user interface of Frama-c and depends
 on frama-c-base.

Package: frama-c-base
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libocamlgraph-ocaml-dev,
 gcc,
Recommends:
 alt-ergo,
 libwhy-coq
Replaces: frama-c (<< 20090902+beryllium+dfsg-1)
Breaks: frama-c (<< 20090902+beryllium+dfsg-1)
Description: Framework for C source code analysis (without gui)
 Frama-C is a framework dedicated to the analysis of the source code
 of software written in C.
 .
 Frama-C gathers several static analysis techniques in a single
 collaborative framework. The collaborative approach of Frama-C allows
 static analyzers to build upon the results already computed by other
 analyzers in the framework. Thanks to this approach, Frama-C provides
 sophisticated tools, such as a slicer and dependency analysis.
 .
 It can be used to:
   * Validate the source code formally
   * Look for potential runtime errors
   * Audit or review it
   * Reverse engineer it to understand its structure
   * Generate formal documentation
 .
 This package provides the library of Frama-c which is useful to build
 plugins for Frama-c and the command-line tools.
