## frama-c 20111001%2bnitrogen%2bdfsg

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  ocaml-best-compilers,
  dh-ocaml (>= 0.9~),
  graphviz,
- libocamlgraph-viewer-ocaml-dev (>> 1.4~),
+ libocamlgraph-viewer-ocaml-dev (>> 1.8~),
  liblablgtk2-gnome-ocaml-dev (>= 2.14.0+dfsg-2~),
  liblablgtksourceview2-ocaml-dev (>= 2.14.0+dfsg-2~)
-Standards-Version: 3.9.0
+Standards-Version: 3.9.2
 Homepage: http://frama-c.com/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/frama-c.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/frama-c.git
