## frama-c 20111001+nitrogen+dfsg

=== Makefile ===
--- 
+++ 
@@ -138,12 +138,15 @@
 endif
 
 BFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_BYTE) \
-	  $(OCAMLVIZ_COMPILER_BYTE)
+	  $(OCAMLVIZ_COMPILER_BYTE) $(OUNIT_COMPILER_BYTE)
 OFLAGS	= $(DEV_FLAGS) $(DEBUG) $(INCLUDES) $(COVERAGE_COMPILER_OPT) \
-	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT)
+	  $(GPROFOPT) $(OCAMLVIZ_COMPILER_OPT) $(OUNIT_COMPILER_OPT) -compact
 
 BLINKFLAGS = $(BFLAGS) -linkall -custom
 OLINKFLAGS = $(OFLAGS) -linkall
+
+DOC_FLAGS= -colorize-code -stars -inv-merge-ml-mli -m A -hide-warnings \
+	$(INCLUDES) $(GUI_INCLUDES)
 
 # Libraries generated by Frama-C
 GEN_BYTE_LIBS=
@@ -154,17 +157,48 @@
 	$(GEN_BYTE_LIBS)
 OPT_LIBS = nums.cmxa unix.cmxa bigarray.cmxa str.cmxa
 
+# For using Zarith:
+ifeq ($(HAS_ZARITH),yes)
+#ZARITH_LINK = -cclib -L/usr/local/Frama-C/macports/lib
+#ZARITH_INC = -I /home/cuoq/zarith
+BYTE_LIBS+= zarith.cma $(ZARITH_LINK)
+OPT_LIBS+= zarith.cmxa $(ZARITH_LINK)
+INCLUDES+= $(ZARITH_INC)
+src/lib/my_bigint.ml: src/lib/my_bigint.ml.zarith
+	$(PRINT_CP) $@
+	$(CP) $< $@
+	$(CHMOD_RO) $@
+else
+src/lib/my_bigint.ml: src/lib/my_bigint.ml.bigint
+	$(PRINT_CP) $@
+	$(CP) $< $@
+	$(CHMOD_RO) $@
+endif
+GENERATED += src/lib/my_bigint.ml
+DISTRIB_FILES+= src/lib/my_bigint.ml.zarith src/lib/my_bigint.ml.bigint
+
 ifeq ("$(NATIVE_DYNLINK)","yes")
 OPT_LIBS+= dynlink.cmxa
 endif
 
 OPT_LIBS+= $(GEN_OPT_LIBS)
 
-ICONS:=  $(addprefix share/, \
+ICONS:= $(addprefix share/, \
 		frama-c.ico frama-c.gif left.png right.png \
-		relies_on_hyp.png failed.png maybe.png attach.png \
-		check.png \
-	)
+		failed.png maybe.png check.png unmark.png )
+
+FEEDBACK_ICONS:= $(addprefix share/feedback/, \
+		never_tried.png \
+		unknown.png \
+		surely_valid.png \
+		surely_invalid.png \
+		considered_valid.png \
+		valid_under_hyp.png \
+		invalid_under_hyp.png \
+		invalid_but_dead.png \
+		unknown_but_dead.png \
+		valid_but_dead.png \
+		inconsistent.png )
 
 # Kernel files to be included in the distribution.
 # Plug-ins should use PLUGIN_DISTRIB_EXTERNAL if they export something else
@@ -172,35 +206,42 @@
 # NB: configure for the distribution is generated in the distrib directory
 # itself, rather than copied: otherwise, it could include references to
 # non-distributed plug-ins.
-DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in cil/LICENSE	\
-      cil/CHANGES cil/doc/*.html cil/doc/*.tex cil/doc/*.gif		\
-      share/frama-c.WIN32.rc share/frama-c.Unix.rc			\
-      $(ICONS)								\
-      man/frama-c.1 cil/doc/*.pdf cil/doc/api/*.html			\
-      cil/doc/examples/*.txt doc/manuals/*.pdf doc/README		\
-      doc/code/*.ml* doc/code/*.css doc/code/*.txt			\
-      doc/code/toc_head.htm doc/code/toc_tail.htm			\
-      tests/*/*.c tests/*/*.h tests/*/*.ml				\
+DISTRIB_FILES:=cil/*/*.ml* cil/src/*/*.ml* cil/*/*.in			\
+      share/frama-c.WIN32.rc share/frama-c.Unix.rc                      \
+      $(ICONS) $(FEEDBACK_ICONS)			 		\
+      man/frama-c.1 doc/manuals/*.pdf doc/README doc/code/*.ml*		\
+      doc/code/*.css doc/code/intro_plugin.txt				\
+      doc/code/intro_kernel_plugin.txt doc/code/intro_occurrence.txt	\
+      doc/code/intro_pdg.txt doc/code/intro_scope.txt			\
+      doc/code/intro_slicing.txt doc/code/intro_sparecode.txt		\
+      doc/code/intro_wp.txt doc/code/toc_head.htm			\
+      doc/code/toc_tail.htm                                             \
+      tests/*/*.c tests/*/*.i tests/*/*.h tests/*/*.ml	                \
       ptests/*.ml* configure.in Makefile share/Makefile.kernel		\
       share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.internal				\
       share/Makefile.dynamic_config.external Changelog config.h.in	\
-      VERSION $(filter-out CVS,licenses/*) share/*.c share/*.h		\
+      VERSION licenses/* share/*.c share/*.h		                \
       share/libc/*.c share/libc/*.h share/libc/sys/*.h			\
-      share/libc/netinet/*.h share/acsl.el 				\
-      share/configure.ac share/Makefile.config.in			\
-      share/Makefile.common share/Makefile.plugin			\
-      share/Makefile.dynamic		                                \
+      share/libc/netinet/*.h share/acsl.el share/configure.ac		\
+      share/Makefile.config.in share/Makefile.common			\
+      share/Makefile.plugin share/Makefile.dynamic			\
       share/Makefile.dynamic_config.external				\
-      share/Makefile.dynamic_config.internal             		\
-      $(filter-out %kui%,src/kernel/*.ml*)		                \
-      external/hptmap.ml* external/unmarshal*.ml*			\
-      src/ai/*.ml* src/buckx/*.ml* src/buckx/*.c src/gui/*.ml*		\
-      src/lib/*.ml* src/logic/*.ml* src/memory_state/*.ml*		\
-      src/misc/*.ml* src/project/*.ml* src/toplevel/*.ml*		\
-      src/type/*.ml* bin/sed_get_make_major bin/sed_get_make_minor	\
-      bin/sed_inplace INSTALL INSTALL_WITH_WHY .make-clean		\
-      .make-clean-stamp .make-ocamlgraph-stamp
+      share/Makefile.dynamic_config.internal               		\
+      src/kernel/*.ml* external/hptmap.ml*			        \
+      external/unmarshal*.ml* external/unz.ml*                          \
+      src/ai/*.ml* src/buckx/*.ml*	                         	\
+      src/buckx/*.c src/gui/*.ml* src/logic/*.ml*                       \
+      $(filter-out src/lib/my_bigint.ml,$(wildcard src/lib/*.ml*))      \
+      src/memory_state/*.ml* src/misc/*.ml* src/project/*.ml*		\
+      src/toplevel/*.ml* src/type/*.ml* bin/sed_get_make_major		\
+      bin/sed_get_make_minor INSTALL INSTALL_WITH_WHY .make-clean	\
+      .make-clean-stamp .make-ocamlgraph-stamp				
+
+# files that are needed to compile API documentation of external plugins
+DOC_GEN_FILES:=$(addprefix doc/code/, \
+      *.css intro_plugin.txt intro_kernel_plugin.txt kernel-doc.ocamldoc \
+      docgen.cm* *.htm)
 
 ################
 # Main targets #
@@ -294,6 +335,23 @@
 BYTE_LIBS+=$(OCAMLVIZ_LIB_BYTE)
 OPT_LIBS+=$(OCAMLVIZ_LIB_OPT)
 
+#########
+# OUnit #
+#########
+
+USE_OUNIT_TOOL=no
+ifeq ($(USE_OUNIT_TOOL),yes)
+  OCAML_LIBDIR :=$(shell ocamlc -where)
+  OUNIT_PATH=$(OCAML_LIBDIR)/../pkg-lib/oUnit
+  OUNIT_COMPILER_BYTE=-I $(OUNIT_PATH)
+  OUNIT_COMPILER_OPT=-I $(OUNIT_PATH)
+  OUNIT_LIB_BYTE=$(OUNIT_PATH)/oUnit.cma
+  OUNIT_LIB_OPT=$(OUNIT_PATH)/oUnit.cmxa
+endif
+
+BYTE_LIBS+=$(OUNIT_LIB_BYTE)
+OPT_LIBS+=$(OUNIT_LIB_OPT)
+
 ##############
 # Ocamlgraph #
 ##############
@@ -309,72 +367,3 @@
 
 lib/graph.cmo: lib/graph.cmi
 	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-lib/graph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-lib/graph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/%,$@) $@
-
-GENERATED+= lib/graph.cmo lib/graph.cmi
-ifneq ($(OCAMLOPT),no)
-GENERATED+= lib/graph.cmx lib/graph.o
-endif
-
-GRAPH_BYTE_LIBS=lib/graph.cmo
-GRAPH_OPT_LIBS=lib/graph.cmx
-GEN_BYTE_LIBS+=$(GRAPH_BYTE_LIBS)
-GEN_OPT_LIBS+=$(GRAPH_OPT_LIBS)
-
-.PRECIOUS: .cmo .cmi .cmx .o .cmxa .cma
-
-# viewgraph and  dgraph (included in ocamlgraph)
-ifeq ($(HAS_GNOMECANVAS),yes)
-
-lib/viewgraph.cmi: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.cmo: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/viewgraph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/view_graph/%,$@) $@
-
-lib/dgraph.cmi: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.cmo: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.cmx: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-lib/dgraph.o: lib/graph.cmi
-	$(PRINT_CP) $@
-	$(CP) $(patsubst lib/%,$(OCAMLGRAPH_LOCAL)/dgraph/%,$@) $@
-
-GRAPH_GUICMO= lib/dgraph.cmo lib/viewgraph.cmo
-GRAPH_GUICMI= $(GRAPH_GUICMO:.cmo=.cmi)
-GRAPH_GUICMX= $(GRAPH_GUICMO:.cmo=.cmx)
-GRAPH_GUIO=  $(GRAPH_GUICMO:.cmo=.o)
-GENERATED+= $(GRAPH_GUICMI) $(GRAPH_GUICMO)
-ifneq ($(OCAMLOPT),no)
-GENERATED+= $(GRAPH_GUICMX) $(GRAPH_GUIO)
-endif
-
-GEN_BYTE_GUI_LIBS+=$(GRAPH_GUICMO)
-GEN_OPT_GUI_LIBS+=$(GRAPH_GUICMX)
-
