=== debian/changelog ===
frama-c (20111001+nitrogen+dfsg-4) unstable; urgency=low

  * Port to OCamlgraph 1.8.2
    - add 0007-Port-to-OCamlgraph-1.8.2.patch
  * Bump Standards-Version to 3.9.3, no changes needed

 -- Mehdi Dogguy <mehdi@debian.org>  Wed, 16 May 2012 14:58:29 +0200

frama-c (20111001+nitrogen+dfsg-3) unstable; urgency=low

  * Include patchlevel2 for Nitrogen 20111001.
    - add debian/patches/0006-Patchlevel2-for-Nitrogen-20111001.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 06 Jan 2012 09:30:44 +0100

frama-c (20111001+nitrogen+dfsg-2) unstable; urgency=low

  * add 0005-Disable-CHMOD_RO-invocations.patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 03 Jan 2012 15:24:55 +0100

frama-c (20111001+nitrogen+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #652257).
  * Update patches:
    - remove 0001-Value-Analysis-Carbon-patchlevel-1.patch
    - remove 0002-Fix-for-issue-727.patch
    - rebase 0003-Add-ocamlgraph-to-DYN_-O-B-LINKFLAGS.patch
    - update 0004-Accept-ocamlgraph-1.8.patch
    - add 0003-Fix-spelling-error-in-binary.patch
    - add 0004-Use-bin-cp-instead-of-usr-bin-install.patch
  * Bump minimum requirement for ocamlgraph to 1.8.
  * Bump Standards-Version to 3.9.2, no changes needed.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 02 Jan 2012 17:29:13 +0100
